Sketcher SketchObject: Difference between revisions

From FreeCAD Documentation
(→‎Introduction: Like Part2DObject, the SketchObject can be attached to planes and faces.)
(Marked this version for translation)
Line 2: Line 2:
<translate>
<translate>


== Introduction ==
== Introduction == <!--T:1-->


<!--T:2-->
A [[Sketcher_SketchObject|Sketcher SketchObject]], or formally a {{incode|Sketcher::SketchObject}}, is the base element to create 2D objects with the [[Sketcher_Workbench|Sketcher Workbench]].
A [[Sketcher_SketchObject|Sketcher SketchObject]], or formally a {{incode|Sketcher::SketchObject}}, is the base element to create 2D objects with the [[Sketcher_Workbench|Sketcher Workbench]].


<!--T:3-->
The {{incode|Sketcher::SketchObject}} is derived from [[Part_Part2DObject|Part Part2DObject]], which means it is a [[Part Feature|Part Feature]] object specialized for 2D geometry. Like Part2DObject, the SketchObject can be attached to planes and faces. In addition to this, the SketchObject can handle geometrical constraints of the lines and curves that are drawn within it.
The {{incode|Sketcher::SketchObject}} is derived from [[Part_Part2DObject|Part Part2DObject]], which means it is a [[Part Feature|Part Feature]] object specialized for 2D geometry. Like Part2DObject, the SketchObject can be attached to planes and faces. In addition to this, the SketchObject can handle geometrical constraints of the lines and curves that are drawn within it.


Line 12: Line 14:
<translate>
<translate>


== How to use ==
== How to use == <!--T:4-->


<!--T:5-->
# Switch to the [[Sketcher Workbench|Sketcher Workbench]].
# Switch to the [[Sketcher Workbench|Sketcher Workbench]].
# Press {{Button|[[File:Sketcher_NewSketch.svg|16px]] [[Sketcher_NewSketch|Sketcher NewSketch]]}}.
# Press {{Button|[[File:Sketcher_NewSketch.svg|16px]] [[Sketcher_NewSketch|Sketcher NewSketch]]}}.
Line 19: Line 22:
# Press {{Button|OK}}.
# Press {{Button|OK}}.


<!--T:6-->
The SketchObject can be used by itself to draw on a plane; however, it is most commonly used in conjunction with the [[PartDesign Workbench|PartDesign Workbench]] to create extruded solids.
The SketchObject can be used by itself to draw on a plane; however, it is most commonly used in conjunction with the [[PartDesign Workbench|PartDesign Workbench]] to create extruded solids.


<!--T:7-->
# Switch to the [[PartDesign Workbench|PartDesign Workbench]].
# Switch to the [[PartDesign Workbench|PartDesign Workbench]].
# Press {{Button|[[File:PartDesign_Body.svg|16px]] [[PartDesign_Body|PartDesign Body]]}}.
# Press {{Button|[[File:PartDesign_Body.svg|16px]] [[PartDesign_Body|PartDesign Body]]}}.
Line 27: Line 32:
# Press {{Button|OK}}.
# Press {{Button|OK}}.


== Properties ==
== Properties == <!--T:8-->


<!--T:9-->
See [[Property|Property]] for all property types that scripted objects can have.
See [[Property|Property]] for all property types that scripted objects can have.


<!--T:10-->
A [[Sketcher_SketchObject|Sketcher SketchObject]] ({{incode|Sketcher::SketchObject}} class) is derived from a [[Part_Part2DObject|Part Part2DObject]] ({{incode|Part::Part2DObject}} class), therefore it shares all the latter's properties.
A [[Sketcher_SketchObject|Sketcher SketchObject]] ({{incode|Sketcher::SketchObject}} class) is derived from a [[Part_Part2DObject|Part Part2DObject]] ({{incode|Part::Part2DObject}} class), therefore it shares all the latter's properties.


<!--T:11-->
In addition to the properties described in [[Part_Part2DObject|Part Part2DObject]], the basic Sketcher SketchObject has the following properties in the [[property editor|property editor]].
In addition to the properties described in [[Part_Part2DObject|Part Part2DObject]], the basic Sketcher SketchObject has the following properties in the [[property editor|property editor]].


=== Data ===
=== Data === <!--T:12-->


<!--T:13-->
{{TitleProperty|Attachment}}
{{TitleProperty|Attachment}}
* {{PropertyData|Map Mode}}: See [[Part Attachment|Part Attachment]] for more information on all attachment mapping modes.
* {{PropertyData|Map Mode}}: See [[Part Attachment|Part Attachment]] for more information on all attachment mapping modes.


<!--T:14-->
{{TitleProperty|Sketch}}
{{TitleProperty|Sketch}}
* {{PropertyData|Constraints}}: named constraints, if they exist; otherwise it is an empty list {{incode|[]}}.
* {{PropertyData|Constraints}}: named constraints, if they exist; otherwise it is an empty list {{incode|[]}}.


=== View ===
=== View === <!--T:15-->


<!--T:16-->
{{TitleProperty|Auto Constraints}}
{{TitleProperty|Auto Constraints}}
* {{PropertyView|Autoconstraints}}: if {{TRUE}} it will try setting constraints when the geometry is drawn.
* {{PropertyView|Autoconstraints}}: if {{TRUE}} it will try setting constraints when the geometry is drawn.


<!--T:17-->
{{TitleProperty|Visibility automation}}
{{TitleProperty|Visibility automation}}
* {{PropertyView|Editing Workbench}}: normally {{incode|SketcherWorkbench}}, it is the name of the workbench to activate when editing the sketch.
* {{PropertyView|Editing Workbench}}: normally {{incode|SketcherWorkbench}}, it is the name of the workbench to activate when editing the sketch.
Line 55: Line 67:
* {{PropertyView|Show Support}}: if {{TRUE}} all objects this sketch is attached to are shown when opening the sketch.
* {{PropertyView|Show Support}}: if {{TRUE}} all objects this sketch is attached to are shown when opening the sketch.


== Scripting ==
== Scripting == <!--T:18-->


<!--T:19-->
{{Emphasis|See also:}} [[FreeCAD Scripting Basics|FreeCAD Scripting Basics]], and [[scripted objects|scripted objects]].
{{Emphasis|See also:}} [[FreeCAD Scripting Basics|FreeCAD Scripting Basics]], and [[scripted objects|scripted objects]].


<!--T:20-->
See [[Part_Feature|Part Feature]] for the general information.
See [[Part_Feature|Part Feature]] for the general information.


<!--T:21-->
A Sketcher SketchObject is created with the {{incode|addObject()}} method of the document.
A Sketcher SketchObject is created with the {{incode|addObject()}} method of the document.
</translate>
</translate>
Line 72: Line 87:
<translate>
<translate>


<!--T:22-->
{{Sketcher Tools navi}}
{{Sketcher Tools navi}}
{{Userdocnavi}}
{{Userdocnavi}}

Revision as of 10:20, 26 November 2019

Introduction

A Sketcher SketchObject, or formally a Sketcher::SketchObject, is the base element to create 2D objects with the Sketcher Workbench.

The Sketcher::SketchObject is derived from Part Part2DObject, which means it is a Part Feature object specialized for 2D geometry. Like Part2DObject, the SketchObject can be attached to planes and faces. In addition to this, the SketchObject can handle geometrical constraints of the lines and curves that are drawn within it.

How to use

  1. Switch to the Sketcher Workbench.
  2. Press Sketcher NewSketch.
  3. Select a Sketch orientation: XY-plane, XZ-plane, or YZ-plane. Optionally also choose Reverse direction, and give an Offset value.
  4. Press OK.

The SketchObject can be used by itself to draw on a plane; however, it is most commonly used in conjunction with the PartDesign Workbench to create extruded solids.

  1. Switch to the PartDesign Workbench.
  2. Press PartDesign Body.
  3. Press PartDesign NewSketch.
  4. Select feature: XY_Plane (Base plane), XZ_Plane (Base plane), or YZ_Plane (Base plane).
  5. Press OK.

Properties

See Property for all property types that scripted objects can have.

A Sketcher SketchObject (Sketcher::SketchObject class) is derived from a Part Part2DObject (Part::Part2DObject class), therefore it shares all the latter's properties.

In addition to the properties described in Part Part2DObject, the basic Sketcher SketchObject has the following properties in the property editor.

Data

Attachment

  • DataMap Mode: See Part Attachment for more information on all attachment mapping modes.

Sketch

  • DataConstraints: named constraints, if they exist; otherwise it is an empty list [].

View

Auto Constraints

  • ViewAutoconstraints: if true it will try setting constraints when the geometry is drawn.

Visibility automation

  • ViewEditing Workbench: normally SketcherWorkbench, it is the name of the workbench to activate when editing the sketch.
  • ViewHide Dependent: if true all objects that depend on the sketch are hidden when opening the sketch.
  • ViewRestore Camera: if true the camera position is saved before opening the sketch, and is restored after closing it.
  • ViewShow Links: if true all objects used in links to external geometry are shown when opening the sketch.
  • ViewShow Support: if true all objects this sketch is attached to are shown when opening the sketch.

Scripting

See also: FreeCAD Scripting Basics, and scripted objects.

See Part Feature for the general information.

A Sketcher SketchObject is created with the addObject() method of the document.

import FreeCAD as App

doc = App.newDocument()
obj = App.ActiveDocument.addObject("Sketcher::SketchObject", "Name")
obj.Label = "Custom label"